UTIL_C = src/util/io.c src/util/key-value-parse.c src/util/log.c 
UTIL_H = src/util/aux_util.h src/util/io.h src/util/key-value-parse.h src/util/log.h src/util/tpm2b.h src/util/tss2_endian.h 
UTIL_SRC = $(UTIL_C) $(UTIL_H)
TSS2_SYS_C = src/tss2-sys/api/Tss2_Sys_AC_GetCapability.c src/tss2-sys/api/Tss2_Sys_AC_Send.c src/tss2-sys/api/Tss2_Sys_ActivateCredential.c src/tss2-sys/api/Tss2_Sys_Certify.c src/tss2-sys/api/Tss2_Sys_CertifyCreation.c src/tss2-sys/api/Tss2_Sys_ChangeEPS.c src/tss2-sys/api/Tss2_Sys_ChangePPS.c src/tss2-sys/api/Tss2_Sys_Clear.c src/tss2-sys/api/Tss2_Sys_ClearControl.c src/tss2-sys/api/Tss2_Sys_ClockRateAdjust.c src/tss2-sys/api/Tss2_Sys_ClockSet.c src/tss2-sys/api/Tss2_Sys_Commit.c src/tss2-sys/api/Tss2_Sys_ContextLoad.c src/tss2-sys/api/Tss2_Sys_ContextSave.c src/tss2-sys/api/Tss2_Sys_Create.c src/tss2-sys/api/Tss2_Sys_CreateLoaded.c src/tss2-sys/api/Tss2_Sys_CreatePrimary.c src/tss2-sys/api/Tss2_Sys_DictionaryAttackLockReset.c src/tss2-sys/api/Tss2_Sys_DictionaryAttackParameters.c src/tss2-sys/api/Tss2_Sys_Duplicate.c src/tss2-sys/api/Tss2_Sys_ECC_Parameters.c src/tss2-sys/api/Tss2_Sys_ECDH_KeyGen.c src/tss2-sys/api/Tss2_Sys_ECDH_ZGen.c src/tss2-sys/api/Tss2_Sys_EC_Ephemeral.c src/tss2-sys/api/Tss2_Sys_EncryptDecrypt.c src/tss2-sys/api/Tss2_Sys_EncryptDecrypt2.c src/tss2-sys/api/Tss2_Sys_EventSequenceComplete.c src/tss2-sys/api/Tss2_Sys_EvictControl.c src/tss2-sys/api/Tss2_Sys_Execute.c src/tss2-sys/api/Tss2_Sys_FieldUpgradeData.c src/tss2-sys/api/Tss2_Sys_FieldUpgradeStart.c src/tss2-sys/api/Tss2_Sys_Finalize.c src/tss2-sys/api/Tss2_Sys_FirmwareRead.c src/tss2-sys/api/Tss2_Sys_FlushContext.c src/tss2-sys/api/Tss2_Sys_GetCapability.c src/tss2-sys/api/Tss2_Sys_GetCommandAuditDigest.c src/tss2-sys/api/Tss2_Sys_GetCommandCode.c src/tss2-sys/api/Tss2_Sys_GetContextSize.c src/tss2-sys/api/Tss2_Sys_GetCpBuffer.c src/tss2-sys/api/Tss2_Sys_GetDecryptParam.c src/tss2-sys/api/Tss2_Sys_GetEncryptParam.c src/tss2-sys/api/Tss2_Sys_GetRandom.c src/tss2-sys/api/Tss2_Sys_GetRpBuffer.c src/tss2-sys/api/Tss2_Sys_GetRspAuths.c src/tss2-sys/api/Tss2_Sys_GetSessionAuditDigest.c src/tss2-sys/api/Tss2_Sys_GetTctiContext.c src/tss2-sys/api/Tss2_Sys_GetTestResult.c src/tss2-sys/api/Tss2_Sys_GetTime.c src/tss2-sys/api/Tss2_Sys_HMAC.c src/tss2-sys/api/Tss2_Sys_HMAC_Start.c src/tss2-sys/api/Tss2_Sys_Hash.c src/tss2-sys/api/Tss2_Sys_HashSequenceStart.c src/tss2-sys/api/Tss2_Sys_HierarchyChangeAuth.c src/tss2-sys/api/Tss2_Sys_HierarchyControl.c src/tss2-sys/api/Tss2_Sys_Import.c src/tss2-sys/api/Tss2_Sys_IncrementalSelfTest.c src/tss2-sys/api/Tss2_Sys_Initialize.c src/tss2-sys/api/Tss2_Sys_Load.c src/tss2-sys/api/Tss2_Sys_LoadExternal.c src/tss2-sys/api/Tss2_Sys_MakeCredential.c src/tss2-sys/api/Tss2_Sys_NV_Certify.c src/tss2-sys/api/Tss2_Sys_NV_ChangeAuth.c src/tss2-sys/api/Tss2_Sys_NV_DefineSpace.c src/tss2-sys/api/Tss2_Sys_NV_Extend.c src/tss2-sys/api/Tss2_Sys_NV_GlobalWriteLock.c src/tss2-sys/api/Tss2_Sys_NV_Increment.c src/tss2-sys/api/Tss2_Sys_NV_Read.c src/tss2-sys/api/Tss2_Sys_NV_ReadLock.c src/tss2-sys/api/Tss2_Sys_NV_ReadPublic.c src/tss2-sys/api/Tss2_Sys_NV_SetBits.c src/tss2-sys/api/Tss2_Sys_NV_UndefineSpace.c src/tss2-sys/api/Tss2_Sys_NV_UndefineSpaceSpecial.c src/tss2-sys/api/Tss2_Sys_NV_Write.c src/tss2-sys/api/Tss2_Sys_NV_WriteLock.c src/tss2-sys/api/Tss2_Sys_ObjectChangeAuth.c src/tss2-sys/api/Tss2_Sys_PCR_Allocate.c src/tss2-sys/api/Tss2_Sys_PCR_Event.c src/tss2-sys/api/Tss2_Sys_PCR_Extend.c src/tss2-sys/api/Tss2_Sys_PCR_Read.c src/tss2-sys/api/Tss2_Sys_PCR_Reset.c src/tss2-sys/api/Tss2_Sys_PCR_SetAuthPolicy.c src/tss2-sys/api/Tss2_Sys_PCR_SetAuthValue.c src/tss2-sys/api/Tss2_Sys_PP_Commands.c src/tss2-sys/api/Tss2_Sys_PolicyAuthValue.c src/tss2-sys/api/Tss2_Sys_PolicyAuthorize.c src/tss2-sys/api/Tss2_Sys_PolicyAuthorizeNV.c src/tss2-sys/api/Tss2_Sys_PolicyCommandCode.c src/tss2-sys/api/Tss2_Sys_PolicyCounterTimer.c src/tss2-sys/api/Tss2_Sys_PolicyCpHash.c src/tss2-sys/api/Tss2_Sys_PolicyDuplicationSelect.c src/tss2-sys/api/Tss2_Sys_PolicyGetDigest.c src/tss2-sys/api/Tss2_Sys_PolicyLocality.c src/tss2-sys/api/Tss2_Sys_PolicyNV.c src/tss2-sys/api/Tss2_Sys_PolicyNameHash.c src/tss2-sys/api/Tss2_Sys_PolicyNvWritten.c src/tss2-sys/api/Tss2_Sys_PolicyOR.c src/tss2-sys/api/Tss2_Sys_PolicyPCR.c src/tss2-sys/api/Tss2_Sys_PolicyPassword.c src/tss2-sys/api/Tss2_Sys_PolicyPhysicalPresence.c src/tss2-sys/api/Tss2_Sys_PolicyRestart.c src/tss2-sys/api/Tss2_Sys_PolicySecret.c src/tss2-sys/api/Tss2_Sys_PolicySigned.c src/tss2-sys/api/Tss2_Sys_PolicyTemplate.c src/tss2-sys/api/Tss2_Sys_PolicyTicket.c src/tss2-sys/api/Tss2_Sys_Policy_AC_SendSelect.c src/tss2-sys/api/Tss2_Sys_Quote.c src/tss2-sys/api/Tss2_Sys_RSA_Decrypt.c src/tss2-sys/api/Tss2_Sys_RSA_Encrypt.c src/tss2-sys/api/Tss2_Sys_ReadClock.c src/tss2-sys/api/Tss2_Sys_ReadPublic.c src/tss2-sys/api/Tss2_Sys_Rewrap.c src/tss2-sys/api/Tss2_Sys_SelfTest.c src/tss2-sys/api/Tss2_Sys_SequenceComplete.c src/tss2-sys/api/Tss2_Sys_SequenceUpdate.c src/tss2-sys/api/Tss2_Sys_SetAlgorithmSet.c src/tss2-sys/api/Tss2_Sys_SetCmdAuths.c src/tss2-sys/api/Tss2_Sys_SetCommandCodeAuditStatus.c src/tss2-sys/api/Tss2_Sys_SetDecryptParam.c src/tss2-sys/api/Tss2_Sys_SetEncryptParam.c src/tss2-sys/api/Tss2_Sys_SetPrimaryPolicy.c src/tss2-sys/api/Tss2_Sys_Shutdown.c src/tss2-sys/api/Tss2_Sys_Sign.c src/tss2-sys/api/Tss2_Sys_StartAuthSession.c src/tss2-sys/api/Tss2_Sys_Startup.c src/tss2-sys/api/Tss2_Sys_StirRandom.c src/tss2-sys/api/Tss2_Sys_TestParms.c src/tss2-sys/api/Tss2_Sys_Unseal.c src/tss2-sys/api/Tss2_Sys_Vendor_TCG_Test.c src/tss2-sys/api/Tss2_Sys_VerifySignature.c src/tss2-sys/api/Tss2_Sys_ZGen_2Phase.c src/tss2-sys/sysapi_util.c 
TSS2_SYS_H = src/tss2-sys/sysapi_util.h 
TSS2_SYS_SRC = $(TSS2_SYS_H) $(TSS2_SYS_C)
TSS2_ESYS_H = src/tss2-esys/esys_crypto.h src/tss2-esys/esys_int.h src/tss2-esys/esys_iutil.h src/tss2-esys/esys_mu.h src/tss2-esys/esys_types.h
TSS2_ESYS_C = src/tss2-esys/api/Esys_ActivateCredential.c src/tss2-esys/api/Esys_Certify.c src/tss2-esys/api/Esys_CertifyCreation.c src/tss2-esys/api/Esys_ChangeEPS.c src/tss2-esys/api/Esys_ChangePPS.c src/tss2-esys/api/Esys_Clear.c src/tss2-esys/api/Esys_ClearControl.c src/tss2-esys/api/Esys_ClockRateAdjust.c src/tss2-esys/api/Esys_ClockSet.c src/tss2-esys/api/Esys_Commit.c src/tss2-esys/api/Esys_ContextLoad.c src/tss2-esys/api/Esys_ContextSave.c src/tss2-esys/api/Esys_Create.c src/tss2-esys/api/Esys_CreateLoaded.c src/tss2-esys/api/Esys_CreatePrimary.c src/tss2-esys/api/Esys_DictionaryAttackLockReset.c src/tss2-esys/api/Esys_DictionaryAttackParameters.c src/tss2-esys/api/Esys_Duplicate.c src/tss2-esys/api/Esys_ECC_Parameters.c src/tss2-esys/api/Esys_ECDH_KeyGen.c src/tss2-esys/api/Esys_ECDH_ZGen.c src/tss2-esys/api/Esys_EC_Ephemeral.c src/tss2-esys/api/Esys_EncryptDecrypt.c src/tss2-esys/api/Esys_EncryptDecrypt2.c src/tss2-esys/api/Esys_EventSequenceComplete.c src/tss2-esys/api/Esys_EvictControl.c src/tss2-esys/api/Esys_FieldUpgradeData.c src/tss2-esys/api/Esys_FieldUpgradeStart.c src/tss2-esys/api/Esys_FirmwareRead.c src/tss2-esys/api/Esys_FlushContext.c src/tss2-esys/api/Esys_GetCapability.c src/tss2-esys/api/Esys_GetCommandAuditDigest.c src/tss2-esys/api/Esys_GetRandom.c src/tss2-esys/api/Esys_GetSessionAuditDigest.c src/tss2-esys/api/Esys_GetTestResult.c src/tss2-esys/api/Esys_GetTime.c src/tss2-esys/api/Esys_HMAC.c src/tss2-esys/api/Esys_HMAC_Start.c src/tss2-esys/api/Esys_Hash.c src/tss2-esys/api/Esys_HashSequenceStart.c src/tss2-esys/api/Esys_HierarchyChangeAuth.c src/tss2-esys/api/Esys_HierarchyControl.c src/tss2-esys/api/Esys_Import.c src/tss2-esys/api/Esys_IncrementalSelfTest.c src/tss2-esys/api/Esys_Load.c src/tss2-esys/api/Esys_LoadExternal.c src/tss2-esys/api/Esys_MakeCredential.c src/tss2-esys/api/Esys_NV_Certify.c src/tss2-esys/api/Esys_NV_ChangeAuth.c src/tss2-esys/api/Esys_NV_DefineSpace.c src/tss2-esys/api/Esys_NV_Extend.c src/tss2-esys/api/Esys_NV_GlobalWriteLock.c src/tss2-esys/api/Esys_NV_Increment.c src/tss2-esys/api/Esys_NV_Read.c src/tss2-esys/api/Esys_NV_ReadLock.c src/tss2-esys/api/Esys_NV_ReadPublic.c src/tss2-esys/api/Esys_NV_SetBits.c src/tss2-esys/api/Esys_NV_UndefineSpace.c src/tss2-esys/api/Esys_NV_UndefineSpaceSpecial.c src/tss2-esys/api/Esys_NV_Write.c src/tss2-esys/api/Esys_NV_WriteLock.c src/tss2-esys/api/Esys_ObjectChangeAuth.c src/tss2-esys/api/Esys_PCR_Allocate.c src/tss2-esys/api/Esys_PCR_Event.c src/tss2-esys/api/Esys_PCR_Extend.c src/tss2-esys/api/Esys_PCR_Read.c src/tss2-esys/api/Esys_PCR_Reset.c src/tss2-esys/api/Esys_PCR_SetAuthPolicy.c src/tss2-esys/api/Esys_PCR_SetAuthValue.c src/tss2-esys/api/Esys_PP_Commands.c src/tss2-esys/api/Esys_PolicyAuthValue.c src/tss2-esys/api/Esys_PolicyAuthorize.c src/tss2-esys/api/Esys_PolicyAuthorizeNV.c src/tss2-esys/api/Esys_PolicyCommandCode.c src/tss2-esys/api/Esys_PolicyCounterTimer.c src/tss2-esys/api/Esys_PolicyCpHash.c src/tss2-esys/api/Esys_PolicyDuplicationSelect.c src/tss2-esys/api/Esys_PolicyGetDigest.c src/tss2-esys/api/Esys_PolicyLocality.c src/tss2-esys/api/Esys_PolicyNV.c src/tss2-esys/api/Esys_PolicyNameHash.c src/tss2-esys/api/Esys_PolicyNvWritten.c src/tss2-esys/api/Esys_PolicyOR.c src/tss2-esys/api/Esys_PolicyPCR.c src/tss2-esys/api/Esys_PolicyPassword.c src/tss2-esys/api/Esys_PolicyPhysicalPresence.c src/tss2-esys/api/Esys_PolicyRestart.c src/tss2-esys/api/Esys_PolicySecret.c src/tss2-esys/api/Esys_PolicySigned.c src/tss2-esys/api/Esys_PolicyTemplate.c src/tss2-esys/api/Esys_PolicyTicket.c src/tss2-esys/api/Esys_Quote.c src/tss2-esys/api/Esys_RSA_Decrypt.c src/tss2-esys/api/Esys_RSA_Encrypt.c src/tss2-esys/api/Esys_ReadClock.c src/tss2-esys/api/Esys_ReadPublic.c src/tss2-esys/api/Esys_Rewrap.c src/tss2-esys/api/Esys_SelfTest.c src/tss2-esys/api/Esys_SequenceComplete.c src/tss2-esys/api/Esys_SequenceUpdate.c src/tss2-esys/api/Esys_SetAlgorithmSet.c src/tss2-esys/api/Esys_SetCommandCodeAuditStatus.c src/tss2-esys/api/Esys_SetPrimaryPolicy.c src/tss2-esys/api/Esys_Shutdown.c src/tss2-esys/api/Esys_Sign.c src/tss2-esys/api/Esys_StartAuthSession.c src/tss2-esys/api/Esys_Startup.c src/tss2-esys/api/Esys_StirRandom.c src/tss2-esys/api/Esys_TestParms.c src/tss2-esys/api/Esys_Unseal.c src/tss2-esys/api/Esys_Vendor_TCG_Test.c src/tss2-esys/api/Esys_VerifySignature.c src/tss2-esys/api/Esys_ZGen_2Phase.c src/tss2-esys/esys_context.c src/tss2-esys/esys_crypto.c src/tss2-esys/esys_free.c src/tss2-esys/esys_iutil.c src/tss2-esys/esys_mu.c src/tss2-esys/esys_tr.c
TSS2_ESYS_SRC = $(TSS2_ESYS_H) $(TSS2_ESYS_C)
TSS2_MU_C = src/tss2-mu/base-types.c src/tss2-mu/tpm2b-types.c src/tss2-mu/tpma-types.c src/tss2-mu/tpml-types.c src/tss2-mu/tpms-types.c src/tss2-mu/tpmt-types.c src/tss2-mu/tpmu-types.c 
TSS2_MU_H = 
TSS2_MU_SRC = $(TSS2_MU_C) $(TSS2_MU_H)
TSS2_RC_C = src/tss2-rc/tss2_rc.c 
TSS2_RC_H = 
TSS2_RC_SRC = $(TSS2_RC_C) $(TSS2_RC_H)